/****************************************************************************
*
*     Header Filename: IntType_Notify_API.cpp
*     Module Name:     IntType_Notify_API
*     Description:     Reactor Subsystem API enable notification of new and removed Interaction Types
*     Author:          Chris Gordon-Smith
*
*     Copyright (C) 2007, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License as published by the
*     Free Software Foundation; either version 2 of the License, or (at your
*     option) any later version.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*	  Amendment History:-
*
*         Version    Date                 Update Description
*         =======    ===========          ==================
*
*
*
*
****************************************************************************/

#include    "globldef.h"
#include    "Library_Headers.h"

namespace API {
int IntType_Notify_API;}  // Exists only to make KDevelop display IntType_Notify_API in explorer

namespace DN {
#include "list.hpp"        // Special purpose - Non STL
}

//--------------  Reactor  Subsystem  --------------------------------------------------------------------------
#include  "IntType_Notify_API.h"
#include  "Reactor.h"
//--------------------------------------------------------------------------------------------------------------

void IntType_Notify_API::Notify_New_IntType(Interaction_Type*  Int_Type_Ptr)


{
    Reactor::Get_Reactor__Ptr()->Notify_New_Int_Type(Int_Type_Ptr);
}


void  IntType_Notify_API::Notify_Removed_IntType(Interaction_Type*  Int_Type_Ptr)

{
    Reactor::Get_Reactor__Ptr()->Notify_Removed_Int_Type(Int_Type_Ptr);
}
