/****************************************************************************
*
*     Module Filename:  Realised_Interaction_Type.h
*     Module Name:      Realised_Interaction_Type
*     Description:      An Interaction Type that is or has been Realised in the Reactor
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2005, 2006, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License Version 2, as published 
*     by the Free Software Foundation.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*      Amendment History:- 
*
*              Version	  Date                        Update Description
*              =======    ===========                 ==================
*
*
*
*
****************************************************************************/

#ifndef Realised_Interaction_Type_H
#define Realised_Interaction_Type_H

class   Interaction_Type;
class   Indexed_Series;

class   Realised_Interaction_Type

{

//===== Data Relationships with other classes ============================================================
    private:
        Interaction_Type*  Interaction_Type_Ptr ;  
        Indexed_Series*    Series_Ptr;  // Data Series used to collect satistics on the Realised_Interaction_Type
//==========================================================================================================

    public:
        Realised_Interaction_Type(Interaction_Type*  Int_Type_Ptr,
                                  const string& Indexed_Series_Name,
                                  const string& Index_Name, 
                                  const string& Value_Name,
                                  const string& Series_List);
        ~Realised_Interaction_Type();
        int  Get_Num_Act_Ints();
        void Increment_Num_Act_Ints(int Num_Ints);
        Indexed_Series* Get_Series_Ptr();
        void  Set_Num_Act_Ints(int Num_Ints);
       
    private:     
//        Interaction_Type*  Interaction_Type_Ptr ;  
//        Indexed_Series*       Series_Ptr;  // Data Series used to collect satistics on the Realised_Interaction_Type
        int     Num_Act_Ints;
};
#endif  //Realised_Interaction_Type_H
