/****************************************************************************
*
*	  Module Filename:  Form_View_Network.cpp
*	  Module Name:      Form_View_Network
*	  Description:      View the Network
*	  Author:   		Chris Gordon-Smith
*
*     Copyright (C) 2003, 2004, 2005, 2006, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License Version 2, as published 
*     by the Free Software Foundation.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*	  Amendment History:-
*
*		Version	   Date	   			Update Description
*		=======    ===========		==================
*
*
*
*
****************************************************************************/
//  Comment out to disallow tracing this file
//#define  ENABLE_TRACE_FILE  

//  Globally used defines

#include "globldef.h"
#include "Library_Headers.h"

//----------------  User_Interface_Presentation API --------------------------------------------------------------
#include  "GUI_Presentation_API.h"
//----------------------------------------------------------------------------------------------------------------

//--------------  Network Painter Subsystem  --------------------------------------------------------------------
#include "Network_Painter_Prot.h"
//---------------------------------------------------------------------------------------------------------------

//--------------  User Interface Manager  -----------------------------------------------------------------------
#include "Form_View_Network.h" 
//---------------------------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------------------------
// void  TForm__View_Network::Clear()
// 
// //  Clear the View Network Form
// 
// {
// 
// //  Clear the selected node table
// 
// //    Selected_Nodes.Clear();
// //    Network_Painter_Prot__Ptr->Clear();
//  //   Clear_Network_Bitmap();
// //  Clear the ListViews
// 
// //    TListView__Nodes_Ptr->Get_Items()->Clear();
// //    TListView__Connections_Ptr->Get_Items()->Clear();
// }
//----------------------------------------------------------------------------------------------------------

void  TForm__View_Network::Clear_Network_Bitmap()

//  Clear the Network's Network Painter's Bitmap

{
    Network_Painter_Prot__Ptr->Clear_Network_Bitmap();
}
//----------------------------------------------------------------------------------------------------------

void  TForm__View_Network::Display_All()

//  Display the network and the ListViews

{
    TRACE("TForm__View_Network::Display_All");

    Display_Network();
    List_Nodes();
}
//----------------------------------------------------------------------------------------------------------------
void  TForm__View_Network::Display_Network()

//  Display all the Connections and Nodes

{ 
    TRACE("TForm__View_Network::Display_Network");
//  Clear the current image of the network

    Network_Painter_Prot__Ptr->Clear_Network_Image(); 

    Network_Painter_Prot__Ptr->Set_Number_Of_Nodes(Get_Number_Of_Possible_Nodes()); 

    Draw_All_Connections();
    Draw_All_Nodes();
   
    Draw_Text_Output(); 

//  Now display the network

    Network_Painter_Prot__Ptr->Display_Network_Image();  
}
//---------------------------------------------------------------------------------------------------------------
/*
void TForm__View_Network::Draw_Connection(void* Void__Interaction_Ptr,
                            int Conn_Selection_State) const

//  Draw the specified connection on the Network View

{

    Interaction_Type*  IntType__Ptr = static_cast<Interaction_Type*> (Void__Interaction_Ptr);

    int Interaction_Type_Identifier;
    Interaction_Type_Enum  Interaction_Type_Enumr;
    int Reactant1_Identifier;
    int Reactant2_Identifier;
    int Product1_Identifier;
    int Product2_Identifier;
    int Catalyst_Identifier;

    IntType__Ptr->Get_Int_Type_Characteristics(Interaction_Type_Identifier,
                                               Interaction_Type_Enumr,
                                               Reactant1_Identifier,
                                               Reactant2_Identifier,
                                               Product1_Identifier,
                                               Product2_Identifier,
                                               Catalyst_Identifier);

    if (Interaction_Type_Enumr == Interaction_Type_Enumr__Fission)
    THEN
        Network_Painter_Prot__Ptr->Draw_Fission(Reactant1_Identifier,
                                                Product1_Identifier,
                                                Product2_Identifier,
                                                1,      // Draw all lines withthe same width
                                                Conn_Selection_State,
                                                true);
    ELSEIF (Interaction_Type_Enumr == Interaction_Type_Enumr__Constr)
    THEN
        Network_Painter_Prot__Ptr->Draw_Construction(Reactant1_Identifier,
                                                    Reactant2_Identifier,
                                                    Product1_Identifier,
                                                    1,      // Draw all lines withthe same width
                                                    Conn_Selection_State,
                                                    true); // Draw for first time, so create a Network Display Item
                                                            // in case need to redraw;

    ELSEIF (Interaction_Type_Enumr == Interaction_Type_Enumr__Transfm)
    THEN
        Network_Painter_Prot__Ptr->Draw_Transformation(Reactant1_Identifier,
                                                       Product1_Identifier,
                                                       1,      // Draw all lines withthe same width
                                                       Conn_Selection_State,
                                                       true);

    ELSE
        Assert (true == false, "TForm__View_Network::Draw_Connection - Invalide Interaction Type");
    ENDIF
}
*/
//----------------------------------------------------------------------------------------------------------
void TForm__View_Network::Draw_Connections_For_Selected_Nodes()

//  Draw the Connections matching all of the selected Nodes

{
    list<void*> List__Of_Connections;

    Get_Conns_Matching_All_Sel_Nodes (List__Of_Connections);

    list<void*>::iterator  Iter__Connection_List = List__Of_Connections.begin();
    while (Iter__Connection_List != List__Of_Connections.end())
    BEGIN
        Draw_Connection(*Iter__Connection_List, EOpt_Connection_Selected);
        Iter__Connection_List++;
    END    
}
//----------------------------------------------------------------------------------------------------------

/* void  TForm__View_Network::Draw_Selected_Nodes()

//  Draw the Nodes that are currently selected.
//  Use colour to show the Selection State.  

{
    for(bool Continue_Flag = Selected_Nodes.Iter_To_First();
        Continue_Flag == true;
        Continue_Flag = Selected_Nodes.Iter_To_Next())
    {

//      Draw the selected Nodes




        Network_Painter_Prot__Ptr->
            Draw_Molecule_Type(Selected_Nodes.Get_Current_Node(),
                               100,      // Display One Molecule
                               Selected_Nodes.Get_Node_Selection_State(Selected_Nodes.Get_Current_Node()),
                               true); // Store for redisplay
    }
}
*/
//----------------------------------------------------------------------------------------------------------
/*void TForm__View_Network::FormClose(TObject *Sender,TCloseAction &Action)

//  Close Form handler

{
    Close_View();
    Action = caFree;
}         */
//----------------------------------------------------------------------------------------------------------
void    TForm__View_Network::Get_Conns_Matching_All_Sel_Nodes(list<void*>&  List__Of_Connections)
                                                           
// Populates a list of Connections which each touch all of the selected Nodes,
// and which match that Node Selection States.  That is, in order to be included in the list,
// a Connection must:-

//  *   Touch all of the Selected Nodes
//  *   Match the Node selection State at each of the Connection end points
//      Ie,  a Catalyst end point must match a Node selected as Catalyst, etc.

//  The steps in the algorithm are:-

//  *   Find the first selected node
//  *   Produce a list of connections associated with this node which match the
//      Selection State at that Node
//  *   Produce a list of connections which are in the list above, but which do not
//      match the other selected Nodes and their Selection States
//  *   Remove these from the original list

//  *   The result is the required list of Connections 


{
    if (Selected_Nodes.Iter_To_First() == true)
    THEN

//      Produce a list of connections associated with the node identified above and
//      which match its Selection State

        int First_Selected_Node_Index = Selected_Nodes.Get_Current_Node();
        Enum_Node_Selection_State  First_Node_Sel_State;

        First_Node_Sel_State = Selected_Nodes.Get_Node_Selection_State(First_Selected_Node_Index);

        Get_Conns_Matching_Node_And_Type(List__Of_Connections,
                                         First_Selected_Node_Index,
                                         First_Node_Sel_State);

//      Produce a list of connections which are in the list above, but NOT also common to all
//      the other selected nodes

        vector<void*> Vector__Connections_To_Remove;

        for (list<void*>::iterator Iter1 = List__Of_Connections.begin();
             Iter1 != List__Of_Connections.end();
             Iter1++)
        BEGIN

//          Determine whether the current Connection touches each Selected Node
//          and matches the Selection State in each case

            bool  Keep_Connection_Flag = true;  //  Will switch off later if Connection not OK at all Nodes
            for (bool Continue_Flag1 = Selected_Nodes.Iter_To_First();
                 Continue_Flag1 == true;

                 Continue_Flag1 = Selected_Nodes.Iter_To_Next())

            BEGIN
                int Selected_Node_Index = Selected_Nodes.Get_Current_Node();
                Enum_Node_Selection_State  Node_Sel_State;
                Node_Sel_State = Selected_Nodes.Get_Node_Selection_State(Selected_Node_Index);
                list<void*>  List__Of_Candidate_Connections;

//              Produce a list of 'Candidate' Connections touching the Node under consideration
//              and matching its Selection State at that Node



                Get_Conns_Matching_Node_And_Type(List__Of_Candidate_Connections,
                                                 Selected_Node_Index,
                                                 Node_Sel_State);

//              Check whether one of these Candidates is the Connection under
//              consideration by the outer loop

                bool Conn_Found_For_Current_Node = false;
                for (list<void*>::iterator Iter2 = List__Of_Candidate_Connections.begin();
                     Iter2 != List__Of_Candidate_Connections.end();

                     Iter2++)
                BEGIN
                    if ((*Iter1)  == (*Iter2))
                    THEN    //  The Candidate is the Connection inder consideration
                        Conn_Found_For_Current_Node = true;
                        break;
                    ENDIF
                END

                if (!Conn_Found_For_Current_Node)
                THEN
                    Keep_Connection_Flag = false;    // The Connection under consideration does not
                ENDIF                                // match the current Node, so ....
            END

            if (!Keep_Connection_Flag)
            THEN
                Vector__Connections_To_Remove.push_back(*Iter1);   //  ... the Connection under
            ENDIF                                                  // consideration will be removed.
        END


//      Remove connections from the original list that are not common to all the selected nodes

        for (vector<void*>::iterator Iter = Vector__Connections_To_Remove.begin();
             Iter != Vector__Connections_To_Remove.end();
             Iter++)
        BEGIN
             List__Of_Connections.remove(*Iter);
        END  
    ENDIF
}

//----------------------------------------------------------------------------------------------------------

void    TForm__View_Network::Initialise_Form(int  Number_Of_Nodes, 
                                             bool Display_All_Connections_Ind,
                                             Widget_Ids::Drawing_Area_Id  Draw_Area_Id)

//  Initialise the View Network Form 

{
//    TListView__Nodes_Ptr->Set_Width(Laz_TabSheet_Ptr->Get_Width()/6);
        
//  Now create a Network_Painter for the Form's PaintBox
//  Pass configuration parameters to the Constructor
//  Also pass the address of the PaintBox to which the Network Painter will write

    int Nodes_Per_Display_Row = static_cast <int> (std::sqrt(double(Number_Of_Nodes)));
//    if (Nodes_Per_Display_Row > ((TScreen::Get_Width()/10) - 5))
//    THEN    
//       Nodes_Per_Display_Row = (TScreen::Get_Width()/10) - 5;
//    ENDIF   
    
    Network_Painter_Prot__Ptr = Network_Painter_Prot::Make_Network_Painter(Nodes_Per_Display_Row,
                                                                           40,   //SpaceInPixelsBetweenNodes
                                                                           0.01, //Typical_Connection_Strength
                                                                           10,   //Typical_Node_Strength
                                                            //               TPaintBox__Network_Display_Ptr,
                                                                           Display_All_Connections_Ind,
                                                                           Draw_Area_Id); 
//  Enable the Network Painter's Paintbox

//    TPaintBox__Network_Display_Ptr->Enable();

//  Display the Network on the PaintBox

 //   Display_Network();

//  Now list the Nodes on the ListView

 //   List_Nodes();

}
//----------------------------------------------------------------------------------------------------------


void TForm__View_Network::Set_Number_Of_Nodes(int Num_Nodes)

{
    Network_Painter_Prot__Ptr->Set_Number_Of_Nodes(Num_Nodes);
}

//----------------------------------------------------------------------------------------------------------

TForm__View_Network::TForm__View_Network()
//    : TForm(Owner)

//  Constructor 

{

}
//----------------------------------------------------------------------------------------------------------

//void TForm__View_Network::TPaintBox__Network_Display_Clear_Bitmap()

//  Clear the PaintBox's Bitmap

//{
//    Clear_Network_Bitmap();
//}
//---------------------------------------------------------------------------
//void TForm__View_Network::TPaintBox__Network_Display_Paint()


//  OnPaint Event Handler. Draws the PaintBox initially, and ensures
//  that it is redrawn correctly in response to certain events on the desktop.
//  Eg another window being displayed over the PaintBox and then
//  being moved to reveal the PaintBox again.

//  Also Lists the Nodes - Needed when switching between tabs

//  Normal drawing is handled by the PaintBox's Network_Painter
//{
//    Display_Network();
//    List_Nodes();   
//}
//---------------------------------------------------------------------------

//void TForm__View_Network::TPopup_On_PaintBox_Zoom_In()

//  Invoke the Network Painter's Zoom_In function

//{
//   Network_Painter_Prot__Ptr->Zoom_In();
//}
//---------------------------------------------------------------------------

//void TForm__View_Network::TPopup_On_PaintBox_Zoom_Out()

//  Invoke the Network Painter's Zoom_Out function

//{
//    Network_Painter_Prot__Ptr->Zoom_Out();
//}
//----------------------------------------------------------------------------------------------------------
void TForm__View_Network::Draw_Selected_Connections()

//  Draw the Connections selected on the ListView and display them using the Network_Painter

{/*
    int ListItem_Counter;
    TListItem*          ListItem__Ptr;

//  Don't do anything unless at least one item is selected

//    if (TListView__Connections_Ptr->Get_SelCount() >= 1)
//    THEN

//      Clear the current image of the network

        for (ListItem_Counter = 0;
             ListItem_Counter < TListView__Connections_Ptr->Get_Items()->Get_Count();
             ListItem_Counter++)
        BEGIN
            ListItem__Ptr = TListView__Connections_Ptr->Get_Items()->Get_Item(ListItem_Counter);

            if  (ListItem__Ptr->Get_Selected() == true)
            THEN
//              Draw the Connection on the Bitmap

                Draw_Connection(ListItem__Ptr->Get_Data(), EOpt_Connection_Selected);
            ENDIF
        END
//    END  */
}
//----------------------------------------------------------------------------------------------------------

//void TForm__View_Network::TListView__Connections_MouseUp()

//  Mouse Up handler.
//{
//    Display_Network();  // Draws the network including selected connections
//}
//---------------------------------------------------------------------------

void TForm__View_Network::TListView__Connections_KeyUp()

//  KeyUp handler. Display the selected Connections on the TBitmap

{

    Draw_Selected_Connections();
    Display_Network();

}
//---------------------------------------------------------------------------

//void TForm__View_Network::TListView_Nodes_MouseDown()

// Mouse Down Handler for Nodes ListView


//{
//    TListView*  ListView_Ptr = Get_Laz_ListView_Nodes_Ptr();
//    TListItem*  ListItem_Ptr = ListView_Ptr->Get_Selected();
    
//    if (ListItem_Ptr)
//    THEN
//        ListItem_Ptr->Set_Selected(false);
//    ENDIF   
//}
//-------------------------------------------------------------------------------------------------------------
//void TForm__View_Network::TListView__Nodes_Select_Item(TListItem* Item)

//  List the Connections for the selected Node, if one is selected
//  Also update the network display.
//{
       
//      First clear the existing list

//        TListView__Connections_Ptr->Get_Items()->Clear();
//        string Name = MainForm::Get_Ptr()->Get_PageControl_Ptr()->Get_ActivePage()->Get_Name();
 //       if (Name == string("Main_Tab"))

//        cout << "TForm__View_Network::TListView__Nodes_Select_Item = " << Item << endl;
        
  //      List_Nodes();
//            List_Connections_For_Node(Item->Get_Data());

 
//      Display_Network();
//        MouseDown_On_Nodes_ListView = false;
//}
//---------------------------------------------------------------------------

void TForm__View_Network::Menu_R_MolTyp_List_Add_Mol()  



//  Use requests to Add Molecule of the selected Realisable Molecule Type to Reactor

//  Called from TForm_View_Reactor

{
    Add_Item_Of_Node_Type();
}
//---------------------------------------------------------------------------

void TForm__View_Network::Menu_R_MolTyp_List_Rem_Mol()

//  User requests to Remove a Molecule of the selected Realisable Type from the Reactor
//  Called from TForm_View_Reactor
{
    Remove_Item_Of_Node_Type();

}
//---------------------------------------------------------------------------

void TForm__View_Network::Menu_MolTyp_List_Add_Mol()



//  User requeste to add a Molecule of the selected

//  Type to the Reactor

{
    Add_Item_Of_Node_Type();
}
//---------------------------------------------------------------------------
void TForm__View_Network::Menu_MolTyp_List_Refresh()

//  Refresh the Nodes List. Called from the Molecule_Type List

{
//    TListView__Nodes_Ptr->Get_Items()->Clear();
    List_Nodes();
}
//----------------------------------------------------------------------------------------------------------
void TForm__View_Network::Menu_R_MolTyp_List_Refresh()


//  Refresh the Nodes List

{
//    TListView__Nodes_Ptr->Get_Items()->Clear();
    List_Nodes();
}
//---------------------------------------------------------------------------

//void TForm__View_Network::TListView__Nodes_Compare(TListItem *Item1,

//                                                   TListItem *Item2, int& Compare)

//  Determine Sort order for Nodes

//{
//    Compare = Compare_Nodes(Item1->Get_Data(), Item2->Get_Data());
//}
//----------------------------------------------------------------------------------------------------------
//void  TForm__View_Network::TListView__Connections_Compare(
//      TListItem *Item1, TListItem *Item2,
//      int &Compare)

//  Determine Sort order for Connections

//{

//    Compare = Compare_Connections(Item1->Get_Data(), Item2->Get_Data());
//}

//----------------------------------------------------------------------------------------------------------
void TForm__View_Network::List_Interactions_Click()

//  Show the Connections Listview

{
//    TListView__Connections_Ptr->Set_Visible(true);
}
//----------------------------------------------------------------------------------------------------------
//void  TForm__View_Network::TPopup_On_Paintbox_Inc_Conn_Width()

//  Increase the display width of Connections

//{
//   Network_Painter_Prot__Ptr->Increase_Connection_Width();
//}
//----------------------------------------------------------------------------------------------------------
//void TForm__View_Network::TPopup_On_Paintbox_Dec_Conn_Width()

//  Decrease the display width of Connections

//{
//   Network_Painter_Prot__Ptr->Decrease_Connection_Width();
//}
//----------------------------------------------------------------------------------------------------------
//void TForm__View_Network::TPopup_On_Paintbox_Inc_Node_Width()

//  Increase the display width of Nodes



//{/

 //  Network_Painter_Prot__Ptr->Increase_Node_Width();
//}
//---------------------------------------------------------------------------
//void TForm__View_Network::TPopup_On_Paintbox_Dec_Node_Width()

//  Decrease the display width of Nodes

//{
//   Network_Painter_Prot__Ptr->Decrease_Node_Width();
//}
//----------------------------------------------------------------------------------------------------------

/*
void TForm__View_Network::TPaintBox__Net_Disp_Mouse_Down(TMouseButton Button, int X, int Y )

//  Mouse Down event for the PaintBox:  Record the index of the Node at which
//  the mouse is located

{
    if (Button == mbLeft()) // make sure left button is down
    THEN
        Last_MouseDown_Was_Left_Mouse = true;

        Network_Painter_Prot::Screen_Location  Screen_Loc;
        Screen_Loc.X = X;
        Screen_Loc.Y = Y;

        int Node_Index = Network_Painter_Prot__Ptr->Node_Index_For_Screen_Location(&Screen_Loc);

        Selected_Nodes.Set_Node_Index_At_Mouse_Down(Node_Index);

    ELSE
        Last_MouseDown_Was_Left_Mouse = false;
    ENDIF    
}  */
//----------------------------------------------------------------------------------------------------------
//void  TForm__View_Network::TPaintBox__Net_Disp_Mouse_Up(TShiftState Shift, int X, int Y)

//  Mouse Up event for PaintBox:  Update selection state of affected Node(s).
//  If mouse has not moved, then selected node changes its selection state.
//  Otherwise, the selection state of the original node is dragged and dropped to a new node.  

//{ /*
/*    printf ("TForm__View_Network::TPaintBox__Net_Disp_Mouse_Up: X = %d  Y = %d\n", X,Y);
    Network_Painter_Prot::Screen_Location  Screen_Loc;
    Screen_Loc.X = X;
    Screen_Loc.Y = Y;

//  First check if mouse is on a Valid node. If not then return with no action.
    
    if (!Network_Painter_Prot__Ptr->Screen_Location_Is_Valid_Node(&Screen_Loc, Get_Number_Of_Possible_Nodes()))
    THEN
        return;
    ENDIF
    
    int Current_Node_Index = Network_Painter_Prot__Ptr->Node_Index_For_Screen_Location(&Screen_Loc);
                                
    if (Last_MouseDown_Was_Left_Mouse == true) // make sure left button was pressed
    THEN
        if (Current_Node_Index == Selected_Nodes.Get_Node_Index_At_Mouse_Down())
        THEN
//          Mouse has not moved. Deselect all previously selected nodes
//          if Control is not held down.  Current Node takes next selection state

            Enum_Node_Selection_State   Next_Selection_State;
            Next_Selection_State =
                Network_Painter_Prot::Manage_Node_Selection_State::Next
                    (Selected_Nodes.Get_Node_Selection_State(Current_Node_Index));
       
            if (ssCtrl_Pressed(Shift) != true) // Check whether Ctrl pressed
            THEN
                Selected_Nodes.Deselect_All_Nodes();
            END

            Selected_Nodes.Select_Node(Current_Node_Index,Next_Selection_State);
        ELSE

//          Mouse has moved. Select node at new mouse location with the same selection state
//          as the node at the old mouse location. Then Deselect the node at the old mouse location

            int Old_Node_Index = Selected_Nodes.Get_Node_Index_At_Mouse_Down();
            Remove_And_Replace_Connections(Old_Node_Index, Current_Node_Index);

            Selected_Nodes.Select_Node(Current_Node_Index, Selected_Nodes.Get_Node_Selection_State(Old_Node_Index));
            Selected_Nodes.Deselect_Node(Old_Node_Index);
        ENDIF


//        Display_Network();    // Not necessary because MouseUp triggers OnPaint
    ENDIF 
}  */
//---------------------------------------------------------------------------------------------------------------
void TForm__View_Network::Selected_Node_Table::Clear()

//   Clear the Selected Node Table

{
    Table_Of_Selected_Nodes.clear();
}
//----------------------------------------------------------------------------------------------------------
int   TForm__View_Network::Selected_Node_Table::Get_Current_Node() const

//  Return the key to the current item in the Selected Nodes table

{
    return  (*Iter__Table_Of_Selected_Nodes).first;   // first is part of the Pair

                                                      // structure used to implement STL map

}
//----------------------------------------------------------------------------------------------------------

Enum_Node_Selection_State   TForm__View_Network::Selected_Node_Table::Get_Node_Selection_State(int  Node_Index)

//  Return the selection state of the specified Node

{
    if (Table_Of_Selected_Nodes.count(Node_Index)  == 1)
    THEN
        return  Table_Of_Selected_Nodes[Node_Index];
    ELSE

        return  EOpt_Node_Not_Selected;
    ENDIF
}
//----------------------------------------------------------------------------------------------------------
bool  TForm__View_Network::Selected_Node_Table::Iter_To_First()

//  Make the first selected item in the Selected Nodes table the current item
//  Use Iter_To_Next to find a selected item if necessary.
//  Return true if a selected item is found. Otherwise return false.

{

    if (Table_Of_Selected_Nodes.empty())
    THEN
        return false;
    ELSE

        Iter__Table_Of_Selected_Nodes = Table_Of_Selected_Nodes.begin();

        if (Get_Node_Selection_State(Get_Current_Node())
                                ==
            EOpt_Node_Not_Selected)
        THEN
            return  Iter_To_Next();
        ELSE
            return true;
        ENDIF
    ENDIF
}

//----------------------------------------------------------------------------------------------------------
bool  TForm__View_Network::Selected_Node_Table::Iter_To_Next()

//  Make the next selected item in the Selected Nodes table the current item
//  Return true if a selected item is found. Otherwise return false.

{
    Assert(Iter__Table_Of_Selected_Nodes != Table_Of_Selected_Nodes.end(),
           "TForm__View_Network::Selected_Node_Table::Iter_To_Next() - Attempt to iterate beyond end");

    while(true)
    BEGIN
        Iter__Table_Of_Selected_Nodes++;

        if (Iter__Table_Of_Selected_Nodes == Table_Of_Selected_Nodes.end())
        THEN
            return false;
        ELSE
            if (Get_Node_Selection_State(Get_Current_Node())
                                !=
                    EOpt_Node_Not_Selected)
            THEN
                return true;
            ENDIF
        ENDIF
    END        
}

//----------------------------------------------------------------------------------------------------------

void  TForm__View_Network::Selected_Node_Table::Select_Node
            (int  Node_Index, Enum_Node_Selection_State  Selection_State)


//  Select the specified Node with the specified selection state.

{
    Table_Of_Selected_Nodes[Node_Index] =  Selection_State;
}
//----------------------------------------------------------------------------------------------------------
void  TForm__View_Network::Selected_Node_Table::Deselect_All_Nodes()


//  Deselect all nodes by clearing the table that stores the selection states 


{
    Table_Of_Selected_Nodes.clear();
}

//----------------------------------------------------------------------------------------------------------
void  TForm__View_Network::Selected_Node_Table::Deselect_Node(int  Node_Index)

//  Deselect the specified Node

{
    Table_Of_Selected_Nodes[Node_Index] =  EOpt_Node_Not_Selected;
}
//----------------------------------------------------------------------------------------------------------
int   TForm__View_Network::Selected_Node_Table::Get_Node_Index_At_Mouse_Down(void) const



//  Return the value of the Node Index at the last Mouse Down event on the PaintBox

{
    return  Node_Index_At_Mouse_Down;
}
//----------------------------------------------------------------------------------------------------------
void  TForm__View_Network::Selected_Node_Table::Set_Node_Index_At_Mouse_Down(int  Node_Index)

//  Set the value of Node_Index_At_Mouse_Down


{
    Node_Index_At_Mouse_Down = Node_Index;
}

//----------------------------------------------------------------------------------------------------------           
//void TForm__View_Network::TPopup_On_PBox_View_AllConnsClick()

//  View option to switch on display of Unselected Connections
//{

//    TPopup_On_PBox_View_AllConns->Set_Checked(true);
//    TPopup_On_PBox_View_SelConns->Set_Checked(false);
//    Network_Painter_Prot__Ptr->Control_Unselected_Conn_Display(true);
//}
//---------------------------------------------------------------------------

//void TForm__View_Network::TPopup_On_PBox_View_SelConnsClick()

//  View option to switch off display of Unselected Connections
//{
//    TPopup_On_PBox_View_SelConns->Set_Checked(true);
//    TPopup_On_PBox_View_AllConns->Set_Checked(false);
 //   Network_Painter_Prot__Ptr->Control_Unselected_Conn_Display(false);
//}
//---------------------------------------------------------------------------


